stages:
  - test
  - deploy

include:
  - template: Security/SAST.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml

unit test:
  image: $RUBY_IMAGE
  stage: test
  script:
  - gem install bundler rubocop
  - bundle config set --local frozen 'true'
  - bundle install
  - bundle exec rspec
  parallel:
    matrix:
      - RUBY_IMAGE: [ruby:3.0,ruby:3.1,ruby:3.2]
  coverage: "/.*\\((\\d+\\.\\d+\\%)\\).*/"
  artifacts:
    paths:
    - coverage/
  except:
  - tags

publish gem:
  image: ruby:3.2
  stage: deploy
  when: manual
  script:
    - gem build -o semver_dialects.gem semver_dialects.gemspec
    - gem push semver_dialects.gem
  only:
    - master
